apiVersion: v1
kind: Service
metadata:
  name: {{ include "minecraft.fullname" . }}
  labels:
    {{- include "minecraft.labels" . | nindent 4 }}
spec:
  type: {{ .Values.service.type }}
  {{- if .Values.service.loadBalancerIP }}
  loadBalancerIP: {{ .Values.service.loadBalancerIP }}
  {{- end }}
  {{- if .Values.service.externalIPs }}
  externalIPs: 
{{ .Values.service.externalIPs | toYaml | indent 4 }}
  {{- end }}
  ports:
    - port: {{ .Values.service.gamePort }}
      targetPort: game
      protocol: TCP
      name: game
    - port: {{ .Values.service.rconPort }}
      targetPort: rcon
      protocol: TCP
      name: rcon
  selector:
    {{- include "minecraft.selectorLabels" . | nindent 4 }}
{{- if .Values.metrics.enabled }}
---
apiVersion: v1
kind: Service
metadata:
  name: {{ include "minecraft.fullname" . }}-metrics
  labels:
    {{- include "minecraft.labels" . | nindent 4 }}
spec:
  type: {{ .Values.metrics.service.type }}
  {{- if .Values.metrics.service.loadBalancerIP }}
  loadBalancerIP: {{ .Values.metrics.service.loadBalancerIP }}
  {{- end }}
  {{- if .Values.metrics.service.externalIPs }}
  externalIPs: 
{{ .Values.metrics.service.externalIPs | toYaml | indent 4 }}
  {{- end }}
  ports:
    - port: {{ .Values.metrics.service.port | default "9225" }}
      targetPort: metrics
      protocol: TCP
      name: metrics
  selector:
    {{- include "minecraft.selectorLabels" . | nindent 4 }}
{{- end }}
{{- if .Values.extraPorts }}
---
apiVersion: v1
kind: Service
metadata:
  name: {{ include "minecraft.fullname" . }}-extra
  labels:
    {{- include "minecraft.labels" . | nindent 4 }}
spec:
  type: {{ .Values.service.type }}
  ports:
{{- range .Values.extraPorts }}
    - port: {{ .containerPort }}
      targetPort: {{ .name }}
      protocol: {{ .protocol }}
      name: {{ .name }}
{{- end }}
  selector:
    {{- include "minecraft.selectorLabels" . | nindent 4 }}
{{- end}}
